' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2017                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' C_CAO
'
' 쐬 : N.Kubo
'
'  : 2017/10/7 
'
' Affine Sample Program
' -----------------------------------------------------------------



Public Class FormEdge2D


    '摜i[̈
    Private m_image As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()


    '摜i[̈(ʗp)
    Private m_dst As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()

    'rfI̓NX
    Private m_video As FVIL.Video.CFviVideo

    '2GbWNX(փGbWtB^)
    Private m_corr_edge As FVIL.Edge.CFviEdge2DCorrelation = New FVIL.Edge.CFviEdge2DCorrelation()

    '2GbWNX(\[xbtB^)
    Private m_sobel_edge As FVIL.Edge.CFviEdge2DSobel = New FVIL.Edge.CFviEdge2DSobel()

    '2GbWop[^NX(փGbW@)
    Private m_corr_param As FVIL.Edge.CFviEdge2DCorrelationParam = New FVIL.Edge.CFviEdge2DCorrelationParam()

    '2GbWop[^NX(Sobel@)
    Private m_sobel_param As FVIL.Edge.CFviEdge2DSobelParam = New FVIL.Edge.CFviEdge2DSobelParam()


    'GbW\pI[o[CNX錾
    Private m_overlayEdge As FVIL.GDI.CFviOverlay = New FVIL.GDI.CFviOverlay()

    'ԌvNX
    Private m_timer As FVIL.CFviTimeCounter = New FVIL.CFviTimeCounter()

    'init@CݒtH[
    Public formBroseIni As Form_BROWSEINI = New Form_BROWSEINI()

    'init@CitpXj
    Public m_strIniFilePath As String
    'rfIfoCX̃I[v
    Private m_flgVideoOpened As Boolean
    'ԑp
    Dim msec As Double = 0




    ''' <summary>
    ''' tH[\Jn Cxgnh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gpmF܂B
    ''' </remarks>
    Private Sub FromMain_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown


        'gp̊mF
        Dim licence_dialog As New dialogLicence
        If (licence_dialog.ShowDialog(Me) <> Windows.Forms.DialogResult.OK) Then
            Me.Close() 'gpȂꍇ̓TvvO̓I
            Exit Sub
        End If

        'init@CI
        fnSetIniFile()

        '`imagẽZbg
        cFviImageView1.Image = m_image


        'I[o[C̒ǉ
        cFviImageView1.Display.Overlays.Add(m_overlayEdge)



    End Sub


    Private Sub FormEdge2D_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'FVIL̏
        'AvP[VNA ̊֐ĂяoăCuĂB 
        '̎ACZX̔F؂s܂BpԒłĂȀ͕KsKvL܂B 
        'sȂꍇ́AveNgꂽNX̎sł܂B
        FVIL._SetUp.InitVisionLibrary()

        'ԕϐ̏
        m_flgVideoOpened = False

        'vԃeLXg{bNX
        TextBoxTime.Text = "0"

        'gK[hR{{bNX
        ComboBoxTrigger.Items.Clear()
        ComboBoxTrigger.Items.Add("m[}")
        ComboBoxTrigger.Items.Add("gK")
        ComboBoxTrigger.Items.Add("OgK")
        ComboBoxTrigger.SelectedIndex = 0




        'GbWtB^IR{{bNX
        comboBoxSelectFilter.Items.Clear()
        comboBoxSelectFilter.Items.Add("փGbW")
        comboBoxSelectFilter.Items.Add("\[x")
        comboBoxSelectFilter.SelectedIndex = 0

        ' ێGbWzxIR{{bNX
        comboBoxMagMode.Items.Clear()
        comboBoxMagMode.Items.Add("XY")
        comboBoxMagMode.Items.Add("SQRT")
        comboBoxMagMode.SelectedIndex = 0

    End Sub




    ''' <summary>
    ''' init@CI֐
    ''' </summary>
    ''' <remarks>
    ''' init@C̑I܂B
    ''' </remarks>
    Private Sub fnSetIniFile()

        Dim formbroseini As New Form_BROWSEINI  'init@Cݒ

        'init@C̑I
        m_strIniFilePath = ""
        If (Form_BROWSEINI.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            m_strIniFilePath = Form_BROWSEINI.strIniFilePath
        End If

        If (m_strIniFilePath.Length > 0) Then
            Try
                'ݒt@C̃[hƃfoCXI[v
                m_video = FVIL.Video.Function.CreateInstance(m_strIniFilePath)
                '摜TCY
                m_video.ChangeImageSize(m_image)
                m_flgVideoOpened = True

                'Xe[^X\̍XV
                'gK[h̎擾
                ComboBoxTrigger.SelectedIndex = m_video.Trigger
                'JIԂ̎擾
                If (m_video.DeviceType <> FVIL.Video.DeviceType.RICE001) Then
                    NumericUpDownExposure.Value = m_video.ExposureTime

                End If

                btnGrabOne.Enabled = True
            Catch ex As FVIL.CFviException
                'G[
                MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                'G[
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        ElseIf (Form_BROWSEINI.UseFileFlg = True) Then
            btnGrabOne.Enabled = False
        Else
            'init@CȈꍇ̓TvvO̓I
            Me.Close()
            Exit Sub
        End If

    End Sub


    ''' <summary>
    ''' Grab One{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J荞݁B
    ''' </remarks>
    Private Sub btnGrabOne_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrabOne.Click
        Try
            formBroseIni.UseFileFlg = False

            'foCX^Cv
            Select Case m_video.DeviceType
                Case FVIL.Video.DeviceType.FVC05, FVIL.Video.DeviceType.FVC06, FVIL.Video.DeviceType.FVC07, FVIL.Video.DeviceType.FV1300, FVIL.Video.DeviceType.GP440, FVIL.Video.DeviceType.RICE001
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    m_video.GrabImageSync(m_image)
                    'ԑI
                    msec = m_timer.Stop()
                Case FVIL.Video.DeviceType.FHC3312
                    Dim video As FVIL.Video.CFviVideoFHC3312 = DirectCast(m_video, FVIL.Video.CFviVideoFHC3312)
                    Dim contgrab As FVIL.Video.CFviContinuousGrabFHC3312 = video.ContinuousGrab
                    'bN
                    contgrab.MemoryLock(m_image)
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    contgrab.GrabSync(1)
                    'ԑI
                    msec = m_timer.Stop()
                Case FVIL.Video.DeviceType.FHC3313
                    Dim video As FVIL.Video.CFviVideoFHC3313 = DirectCast(m_video, FVIL.Video.CFviVideoFHC3313)
                    Dim contgrab As FVIL.Video.CFviContinuousGrabFHC3313 = video.ContinuousGrab
                    'bN
                    contgrab.MemoryLock(m_image)
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    contgrab.GrabSync(1)
                    'ԑI
                    msec = m_timer.Stop()
            End Select
            TextBoxTime.Text = msec.ToString("0.000")   '莞ԕ\
            'ĕ`
            cFviImageView1.Refresh()
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try



    End Sub

    ''' <summary>
    ''' Trigger ModeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' m[}[hEgK[hEOgK[h̑IB
    ''' </remarks>
    Private Sub ComboBoxTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTrigger.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.Trigger = ComboBoxTrigger.SelectedIndex
                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)
            End If
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub



    ''' <summary>
    ''' Exposure NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JIԂ̐ݒB
    ''' </remarks>
    Private Sub Exposure_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownExposure.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.ExposureTime = NumericUpDownExposure.Value
            End If
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' LoadFile {^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ͉摜t@C̃[hB
    ''' </remarks>
    Private Sub btnLoadImageFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadImageFile.Click

        '`
        m_overlayEdge.Figures.Clear()


        Form_BROWSEINI.UseFileFlg = True

        '͉摜t@C̃[h
        openFileDialog1.FileName = ""
        openFileDialog1.Filter = "Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        openFileDialog1.Filter += "|Png t@C (*.png)|*.png"
        openFileDialog1.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        openFileDialog1.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        openFileDialog1.DefaultExt = "*.bmp"
        If ((openFileDialog1.FileNames.Length <= 0) Or (openFileDialog1.ShowDialog(Me) = Windows.Forms.DialogResult.Cancel)) Then
            Return
        End If

        Try
            FVIL.File.Function.LoadImageFile(openFileDialog1.FileName, m_image, FVIL.PixelMode.Unpacking)
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try


        cFviImageView1.Image = m_image
        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' Save Image{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜ۑ
    ''' </remarks>
    Private Sub ButtonSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveImage.Click
        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"
        ofdlg.OverwritePrompt = True

        If (ofdlg.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            Try
                '̊֐́AȈՓIɉ摜t@C̕ۑŝׂ̂łB 
                '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 
                FVIL.File.Function.SaveImageFile(ofdlg.FileName, CFviImageView1.Image)

                'ۑt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                '1) bmpt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                'file.Save(ofdlg.FileName, m_image)

                '2) jpgt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                'file.Save(ofdlg.FileName, m_image)
            Catch ex As FVIL.CFviException
                Dim msg As System.String = System.String.Format("CuO𔭍s܂Bcode={0} func={1}", ex.ErrorCode, ex.Function)
                Select Case (ex.ErrorCode)
                    Case FVIL.ErrorCode.NOT_SUPPORTED, _
                     FVIL.ErrorCode.INVALID_OBJECT
                        msg += vbCrLf + "T|[gĂȂ摜IuWFNgłB"
                        msg += vbCrLf + "Raw `ŕۑĂB"
                End Select
                MessageBox.Show(msg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If
    End Sub


    ''' <summary>
    ''' x1{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' {ŕ\܂B
    ''' </remarks>
    Private Sub btnMag1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMag1.Click

        '摜̕\{̎擾܂͐ݒs܂B1.0Ǝw肷Ɠ{ŕ\܂B
        '{ĺA0.5Ƃꍇ́AE1/2ƂȂAʐς1/4ɂȂ܂B
        '3.0Ƃꍇ́AE3{ƂȂAʐς9{ɂȂ܂B
        CFviImageView1.Display.Magnification = 1.0      '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' Fit{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
    ''' </remarks>
    Private Sub btnFit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFit.Click

        '摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
        CFviImageView1.FitImageSize()                   '\{𒲐
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' {{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂B
    ''' </remarks>
    Private Sub btnPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonPlus.Click
        Dim Value As Double
        Value = CFviImageView1.Display.Magnification    '{̎擾
        Value = Value + 0.5
        CFviImageView1.Display.Magnification = Value    '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' |{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂BA{OȉɂȂꍇ͔{0.1ŕ\܂B
    ''' </remarks>
    Private Sub btnMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMinus.Click
        Dim Value As Double
        Value = CFviImageView1.Display.Magnification    '{̎擾
        Value = Value - 0.5
        If (Value <= 0) Then
            Value = 0.1       'Oȉݒ肷ƃG[ɂȂ̂0.1ݒ肷
        End If
        CFviImageView1.Display.Magnification = Value    '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' Ascope`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ASCOPE̕\ؑւ܂B
    ''' </remarks>
    Private Sub CheckBoxAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxAscope.CheckedChanged
        'ASCOPEI[oC̐ݒ
        If (CheckBoxAscope.CheckState) Then
            'ASCOPE̕\LɂB
            CFviImageView1.Display.OverlayAscope.Enable = True
            CFviImageView1.Display.OverlayAscope.Active = True
        Else
            'ASCOPE̕\𖳌ɂB
            CFviImageView1.Display.OverlayAscope.Enable = False
            CFviImageView1.Display.OverlayAscope.Active = False
        End If
        CFviImageView1.Refresh()                        'ĕ`

    End Sub



    ''' <summary>
    ''' 2GbWo@s{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2GbWos܂
    ''' </remarks>
    ''' 
    Private Sub buttonEdge2D_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonEdge2D.Click

        '`
        m_overlayEdge.Figures.Clear()

        cFviImageView1.Image = m_dst

        Try
            If (comboBoxSelectFilter.SelectedIndex = 0) Then

                m_corr_edge.SrcImages(0) = m_image
                m_corr_edge.DstImages(0) = m_dst
                m_corr_edge.Validate()
                m_corr_edge.SaveMode = FVIL.Edge.SaveMode.All


                If comboBoxMagMode.SelectedIndex = 0 Then
                    m_corr_edge.MagMode = FVIL.Edge.MagMode.XY
                Else
                    m_corr_edge.MagMode = FVIL.Edge.MagMode.SQRT
                End If


                Dim temp1 As Integer = numericUpDownRegionHeight.Value
                Dim temp2 As Integer = numericUpDownRegionWidth.Value
                If ((temp1 <= temp2) And ((temp1 * temp2) <= 255)) Then
                    m_corr_param.RegionWidth = numericUpDownRegionWidth.Value
                    m_corr_param.RegionHeight = numericUpDownRegionHeight.Value
                Else
                    MessageBox.Show("Ǐ̈TCY̏𖞂Ă܂", "Parameter Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return
                End If

                'փGbWtB^ p[^ݒ
                m_corr_param.SigmoidK = Double.Parse(textBoxSigmoidK.Text.ToString())
                m_corr_param.VarThreshold = Double.Parse(textBoxVarThreshold.Text.ToString())
                m_corr_param.EdgeThreshold = numericUpDownEdgeThreshold.Value
                m_corr_param.NmsLength = numericUpDownNmsLength.Value

                m_corr_edge.Param = m_corr_param

                'QGbWos
                m_corr_edge.Execute()


                'GbW_̕\
                If (checkEdgeDisp.Checked) Then
                    fnEdgeDisp(m_corr_edge.Result)
                End If


            Else
                '2GbWo (\[x)
                m_sobel_edge.SrcImages(0) = m_image
                m_sobel_edge.DstImages(0) = m_dst
                m_sobel_edge.Validate()
                m_sobel_edge.SaveMode = FVIL.Edge.SaveMode.All

                m_sobel_param.EdgeThreshold = numericUpDownEdgeThreshold.Value
                m_sobel_param.NmsLength = numericUpDownNmsLength.Value

                m_sobel_edge.Param = m_sobel_param
                m_sobel_edge.Execute()

                'GbW_̕\
                If (checkEdgeDisp.Checked) Then
                    fnEdgeDisp(m_sobel_edge.Result)
                End If

            End If

            'ĕ`
            cFviImageView1.Refresh()


        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("2GbWo̎sɎs܂BErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try


    End Sub



    ' <summary>
    ' GbW_\
    ' </summary>
    ' <param name="edge_result">FVIL.Edge.CFviEdgeResult</param>
    '<remarks>
    'oGbW_I[o[Cɕ\܂
    ' </remarks>
    Private Sub fnEdgeDisp(ByVal edge_result As FVIL.Edge.CFviEdgeResult)

        'GbW̕\
        For i As Integer = 0 To edge_result.Count - 1
            Dim edge As FVIL.Edge.CFviEdgeData = edge_result(i)

            ' GbWʒu { }[N\ 
            Dim pos As New FVIL.GDI.CFviGdiPoint(edge.Position)
            pos.Size = New System.Drawing.Size(3, 1)
            pos.Style = FVIL.GDI.FigureStyle.Cross
            pos.Pen.Color = System.Drawing.Color.FromArgb(0, 0, 255)
            m_overlayEdge.Figures.Add(pos)
        Next

        cFviImageView1.Image = m_image


    End Sub



    ' <summary>
    ' 2GbWo@IR{{bNX
    ' </summary>
    ' <param name="sender"></param>
    ' <param name="e"></param>
    '<remarks>
    'փGbWE\[x̑IB
    ' </remarks>
    Private Sub comboBoxSelectFilter_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBoxSelectFilter.SelectedIndexChanged
        If (comboBoxSelectFilter.SelectedIndex = 0) Then
            'փGbWpp[^\
            numericUpDownRegionHeight.Visible = True
            numericUpDownRegionWidth.Visible = True
            textBoxSigmoidK.Visible = True
            textBoxVarThreshold.Visible = True
            labelRegionWidth.Visible = True
            labelRegionHeight.Visible = True
            labelSigmoidK.Visible = True
            labelVarThreshold.Visible = True
            labelCondition1.Visible = True
            labelCondition2.Visible = True
            labelCondition3.Visible = True
            'փGbWpp[^lݒ
            numericUpDownEdgeThreshold.Maximum = 255
            numericUpDownEdgeThreshold.Value = m_corr_param.EdgeThreshold
            numericUpDownNmsLength.Value = m_corr_param.NmsLength
        Else
            'փGbWpp[^\
            numericUpDownRegionHeight.Visible = False
            numericUpDownRegionWidth.Visible = False
            textBoxSigmoidK.Visible = False
            textBoxVarThreshold.Visible = False
            labelRegionWidth.Visible = False
            labelRegionHeight.Visible = False
            labelSigmoidK.Visible = False
            labelVarThreshold.Visible = False
            labelCondition1.Visible = False
            labelCondition2.Visible = False
            labelCondition3.Visible = False
            '\[xGbWpp[^lݒ
            numericUpDownEdgeThreshold.Maximum = 1023
            numericUpDownEdgeThreshold.Value = m_sobel_param.EdgeThreshold
            numericUpDownNmsLength.Value = m_sobel_param.NmsLength

        End If
    End Sub



End Class
